#include "dgtftpdownloadprogressbar.h"

#include <QApplication>
#include <QPainter>

DgtFtpDownloadProgressBar::DgtFtpDownloadProgressBar(QObject *parent) :
    QStyledItemDelegate(parent)
{
}

void DgtFtpDownloadProgressBar::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    if(index.column() == 1)
    {
        const QAbstractItemModel *itemModel = index.model();
        int currentSize = itemModel->data(index, Qt::DisplayRole).toInt();
        int fileSize = itemModel->data(itemModel->index(index.row(),2), Qt::DisplayRole).toInt();

        //ķѡ
        QStyleOptionProgressBarV2 progressBarOption;

        QRect rt(option.rect.left() + 4, option.rect.top() + 4,
                 option.rect.width() - 8, option.rect.height() - 8);
        progressBarOption.rect = rt;
        progressBarOption.minimum = 0;
        progressBarOption.maximum = (fileSize ? fileSize : 100);
        progressBarOption.progress = currentSize;
        progressBarOption.textAlignment = Qt::AlignCenter;

        double t;
        if(fileSize)
            t = currentSize * 100.0 / fileSize;
        else
            t = 0;
        progressBarOption.text = QString::number(t, 'f', 1) + "%";
        progressBarOption.textVisible = true;
        //ƽ
        QApplication::style()->drawControl(QStyle::CE_ProgressBar, &progressBarOption, painter);
    }
    else if(index.column() == 2)
    {
        const QAbstractItemModel *itemModel = index.model();
        int fileSize = itemModel->data(index, Qt::DisplayRole).toInt();
        QRect rt(option.rect.left() + 3, option.rect.top() + 3,
                 option.rect.width() - 6, option.rect.height() - 6);
        if(fileSize < 1024)
            painter->drawText(rt,
                              QString("%1 bytes").arg(fileSize));
        else if(fileSize < 1024 * 1024)
            painter->drawText(rt,
                              QString("%1 Kb").arg(QString::number(fileSize / 1024.0, 'f', 2)));
        else if(fileSize < 1024 * 1024 * 1024)
            painter->drawText(rt,
                              QString("%1 Mb").arg(QString::number(fileSize / (1024.0 * 1024), 'f', 2)));
        else
            painter->drawText(rt,
                              QString("%1 Gb").arg(QString::number(fileSize / (1024.0 * 1024 * 1024), 'f', 2)));

    }
    else
    {//Ĭί
        QStyledItemDelegate::paint(painter, option, index);
    }
}
