#ifndef FTPCURL_H
#define FTPCURL_H

#include <QObject>
#include <QFile>

#include <QTime>

#include <QList>

#include <QMutex>

#include "./libcurl/include/curl/curl.h"
#pragma comment(lib, "./libcurl/libcurl_imp.lib")


class Ftpcurl : public QObject
{
    Q_OBJECT
public:
    static void global_init();
    static void global_cleanup();
    explicit Ftpcurl(QString ftpurl, QString filePath, QObject *parent = 0);
    ~Ftpcurl();

    CURLcode exec();
    CURL *CurlHandle() const;

    quint32 sum;
    QTime tmBackup;

    void EmitState(quint32 size, quint32 currentSize,
                   double speed);
signals:
    void TranslateProgress(QString, quint32, quint32,
                           double);


private:
    void setopt(QString url, quint32 offset = 0);

    static size_t procWrite(void *ptr, size_t size, size_t nmemb, void *ourpointer);
    static int procProgress(void *pVoid,
                            double t, /* dltotal */
                            double d, /* dlnow */
                            double ultotal,
                            double ulnow);

private:
    CURL *curl;
    QFile file;
};

class FtpcurlEx : public QObject
{
    Q_OBJECT
public:
    static void global_init();
    static void global_cleanup();
    explicit FtpcurlEx(QObject *parent = 0);
    ~FtpcurlEx();

    void appendTask(QString ftpurl, QString filePath);
    void pause();

    typedef enum {
        eOk,
        eTimeout
    }FtpcurlExcode;
    FtpcurlExcode exec();

signals:
    void TranslateProgress(QString, quint32, quint32, double);

private:
    CURLM *curlm;

    QList<Ftpcurl*> lstTask;

    QMutex muxPause;
    volatile bool bPause;
    bool isPause();
    void setPause(bool bPause);


    quint32 timeoutCount;   //ʱۼ
};

#endif // FTPCURL_H
